<?php
include_once '../conexion.php';

// Permitir la conexión desde cualquier origen
header("Access-Control-Allow-Origin: *");
// Permitir la ejecución de los métodos
header("Access-Control-Allow-Methods: GET, POST, PUT, DELETE");

// Obtener los datos combinados del cuerpo de la solicitud
$data = json_decode(file_get_contents("php://input"), true);

// Verificar si la decodificación JSON fue exitosa
if (json_last_error() !== JSON_ERROR_NONE) {
    responder_json(['error' => 'Malformed JSON: ' . json_last_error_msg()]);
    exit;
}

// Iniciar la transacción
mysqli_autocommit($conn, false);

// Variable para verificar el estado de la transacción
$transaccionExitosa = true;
$errorMensaje = "";

try {
     // Acceder a los valores individuales de los datos combinados
     $cEmpresa_Id = $data['Empresa_id'];
     $cDocFiscal_id = $data['DocFiscal_Id'];
     $cNSerie = $data['NSerie'];
     $cNDocumento = $data['NDocumento'];
     $cFechaEmision = $data['Fecha_Emision'];
     $cFechaTraslado = $data['Fecha_Traslado'];
     $cFechaVencimiento = $data['Fecha_Vcto'];
     $cNombre = mysqli_real_escape_string($conn, $data['Razon_Social']);
     $cDireccion = mysqli_real_escape_string($conn, $data['Direccion']);
     $cTipDocIdent = $data['Tipo_Documento'];
     $cDocIdentidad = $data['DocIdentidad'];
     $cNDias = $data['NDias'];
     $cMoneda = $data['Moneda'];
     $cTipoCambio = $data['Tipo_Cambio'];
     $cAfectoIgv = $data['Afecto_IGV'];
     $cP_Igv = $data['pIGV'];
     $cIgv = $data['IGV'];
     $cAfectDscto = $data['Descuento'];
     $cP_Dscto = $data['pDSCTO'];
     $cDescuento = $data['Descuento'];
     $cAfectoPercepcion = $data['Afecto_Percepcion'];
     $cP_Percepcion = $data['pPercepcion'];
     $cPercepcion = $data['Percepcion'];
     $cAfecto = $data['Valor_Venta'];
     $cInafecto = $data['Inafecto'];
     $cExonerado = $data['Exonerada'];
     $cTotal = $data['Total_Pagar'];
     $cGuiaRemision = $data['NGuiaRemision'];
     $cCancelado = $data['Cancelado'];
     $cIcbp = $data['ICBPER'];
     $cGratuitas = $data['Gratuitas'];
     $cAfectaKardex = $data['Afecta_Kardex'];
     $cAfectaCaja = $data['Afecta_Caja'];
     $cPeriodo = $data['Periodo'];
     $cMes = $data['Mes'];
     $cFormaPago_Id = $data['Forma_Pago'];
     $cCaja_Id = $data['Caja_Id'];
     $cCliente_Id = $data['Cliente_Id'];
     $cEmpleado_id = $data['Empleado_Id'];
     $cSucursal_Id = $data['Sucursal_Id'];
     $cObservacion = mysqli_real_escape_string($conn, $data['Observacion']);
     $cAcuenta = $data['a_Cuenta'];
     $cServicio = $data['Servicio'];
     $cZona_Id = $data['Zona_Id'];
     $cTipoRubro = $data['TipoRubro'];
     if ($cTipoRubro == 1) {
         $cPlaca = $data['Placa'];
         $cValorRef = $data['ValorReferencial'];
     } else {
         $cPlaca = 0;
         $cValorRef = "-";
     }
     $iIdVta = $data['IdVta_M'];
     $cEstado = $data['Estado'];
     
     /*if ($cAfectaKardex == 0 && $cAfectaCaja == 0) {
         $cCanje = 1;
     } else {
         $cCanje = 0;
     }*/
          
    if ($cEstado == 'NUEVO') {

        // Ejemplo de inserción en la tabla productos
        $queryCabecera = "INSERT INTO ventas(empresa_id, docfiscal_id, nserie, ndocumento, fecha_emision, fecha_traslado, fecha_vencimiento, 
        razon_social, direccion, tipo_docidentidad, documento_identidad, nro_dias, moneda, tipo_cambio, afecto_igv, 
        porcentaje_igv, igv, afecto_dscto, porcentaje_dscto, descuento, afecto_percepcion, porcentaje_percepcion, percepcion,
        afecto, inafecto, exonerado, total, guia_remision, cancelado, icbp, gratuitas, afecta_kardex, afecta_caja, periodo, mes, 
        formapago_id, caja_id, cliente_id, empleado_id, sucursal_id, observacion, acuenta, servicio, zona_id, placa_id, valor_referencial)
        VALUES ('$cEmpresa_Id', '$cDocFiscal_id', '$cNSerie', '$cNDocumento', '$cFechaEmision', '$cFechaTraslado', '$cFechaVencimiento', 
        '$cNombre', '$cDireccion', '$cTipDocIdent', '$cDocIdentidad', '$cNDias', '$cMoneda', '$cTipoCambio', '$cAfectoIgv', '$cP_Igv', '$cIgv', 
        '$cAfectDscto', '$cP_Dscto', '$cDescuento', '$cAfectoPercepcion', '$cP_Percepcion', '$cPercepcion', '$cAfecto', '$cInafecto',
        '$cExonerado', '$cTotal', '$cGuiaRemision', '$cCancelado', '$cIcbp', '$cGratuitas', '$cAfectaKardex', '$cAfectaCaja', '$cPeriodo', '$cMes', 
        '$cFormaPago_Id', '$cCaja_Id', '$cCliente_Id', '$cEmpleado_id', '$cSucursal_Id', '$cObservacion', '$cAcuenta', '$cServicio', '$cZona_Id', '$cPlaca', '$cValorRef')";

        $resultadoCabecera = mysqli_query($conn, $queryCabecera);
        if (!$resultadoCabecera) {
            throw new Exception(mysqli_error($conn));
        }

        // Obtener el ID del último registro insertado en la cabecera de ventas
        $idVenta = mysqli_insert_id($conn);

        // ACTUALIZA REGISTRO DE SERIES
        $query = "SELECT numero FROM series_sucursal WHERE empresa_id = $cEmpresa_Id AND sucursal_id = $cSucursal_Id 
           AND nserie = '$cNSerie' FOR UPDATE";
        $result = mysqli_query($conn, $query);
        if (!$result) {
            throw new Exception(mysqli_error($conn));
        }

        $queryUPD = "UPDATE series_sucursal SET numero = numero + 1 WHERE empresa_id = $cEmpresa_Id AND sucursal_id = $cSucursal_Id 
          AND nserie = '$cNSerie'";
        $resultUPD = mysqli_query($conn, $queryUPD);  
        if (!$resultUPD) {
            throw new Exception(mysqli_error($conn));
        }

        // REGISTRO DE VENTAS
        if ($cDocFiscal_id == 2 || $cDocFiscal_id == 4) {
            $queryReg_Ventas = "INSERT INTO registro_ventas(nserie, ndocumento, fecha_emision, fecha_vencimiento, tipo_docidentidad, documento_identidad,
                razon_social, afecto, exonerado, inafecto, igv, total, periodo, mes, moneda, tipo_cambio, docfiscal_id, venta_id, 
                empresa_id, sucursal_id)
                VALUES ('$cNSerie', '$cNDocumento', '$cFechaEmision', '$cFechaVencimiento', '$cTipDocIdent', '$cDocIdentidad', '$cNombre',
                CASE WHEN '$cMoneda' = '02' THEN '$cAfecto' * '$cTipoCambio' ELSE '$cAfecto' END,
                CASE WHEN '$cMoneda' = '02' THEN '$cExonerado' * '$cTipoCambio' ELSE '$cExonerado' END,
                CASE WHEN '$cMoneda' = '02' THEN '$cInafecto' * '$cTipoCambio' ELSE '$cInafecto' END,
                CASE WHEN '$cMoneda' = '02' THEN '$cIgv' * '$cTipoCambio' ELSE '$cIgv' END,
                CASE WHEN '$cMoneda' = '02' THEN '$cTotal' * '$cTipoCambio' ELSE '$cTotal' END,
                '$cPeriodo', '$cMes', '$cMoneda', '$cTipoCambio', '$cDocFiscal_id',
                '$idVenta', '$cEmpresa_Id', '$cSucursal_Id')";
              
            $resultadoReg_Ventas = mysqli_query($conn, $queryReg_Ventas);
            if (!$resultadoReg_Ventas) {
               throw new Exception(mysqli_error($conn));
            }
            
            // CAJA SUNAT
            /*$queryCajaSunat = "INSERT INTO detcaja(cuenta_id, tipo_movcaja, nrecibo, docfiscal_id, nserie, ndocumento, fecha_operacion,
                        fecha_emision, ingreso, partida_id, nombre_partida, moneda, tipo_cambio, movimiento_id, operacion, 
                        observacion, offsystem, empresa_id, sucursal_id)
                     VALUES('4', 'I', CONCAT('$cNSerie','-','$cNDocumento'), '$cDocFiscal_id', '$cNSerie', '$cNDocumento', '$cFechaEmision',
                        '$cFechaEmision', CASE WHEN '$cMoneda' = '02' THEN '$cTotal' * '$cTipoCambio' ELSE '$cTotal' END, '$cCliente_Id', 'CAJA SUNAT', '$cMoneda', '$cTipoCambio', '$idVenta', 'VTA', '$cObservacion', '1', '$cEmpresa_Id',
                        '$cSucursal_Id')";

            $resultadoCajaSunat = mysqli_query($conn, $queryCajaSunat);
            if (!$resultadoCajaSunat) {
                throw new Exception(mysqli_error($conn));
            }*/  
            
        };

        // CAJA
        if ($cAfectaCaja == 1) {
            if ($cFormaPago_Id == 1) {
                $queryCaja = "INSERT INTO detcaja(cuenta_id, tipo_movcaja, nrecibo, docfiscal_id, nserie, ndocumento, fecha_operacion,
                    fecha_emision, ingreso, partida_id, nombre_partida, moneda, tipo_cambio, movimiento_id, operacion, 
                    observacion, offsystem, empresa_id, sucursal_id)
                    VALUES('$cCaja_Id', 'I', CONCAT('$cNSerie','-','$cNDocumento'), '$cDocFiscal_id', '$cNSerie', '$cNDocumento', '$cFechaEmision',
                    '$cFechaEmision', CASE WHEN '$cMoneda' = '02' THEN '$cTotal' * '$cTipoCambio' ELSE '$cTotal' END, '$cCliente_Id', '$cNombre', '$cMoneda', '$cTipoCambio', '$idVenta', 'VTA', '$cObservacion', '1', '$cEmpresa_Id',
                    '$cSucursal_Id')";

                $resultadoCaja = mysqli_query($conn, $queryCaja);
                if (!$resultadoCaja) {
                    throw new Exception(mysqli_error($conn));
                }    
            };
        };

        // CREDITOS POR COBRAR
        if ($cFormaPago_Id == 2) {
           if ($cAcuenta > 0) {
                $queryCajaActa = "INSERT INTO detcaja(cuenta_id, nombre, tipo_movcaja, nrecibo, docfiscal_id, nserie, ndocumento, fecha_operacion,
                    fecha_emision, ingreso, partida_id, nombre_partida, moneda, tipo_cambio, movimiento_id, operacion, 
                    observacion, offsystem, empresa_id, sucursal_id)
                    VALUES('$cCaja_Id', '$cCaja_Nombre', 'I', CONCAT('$cNSerie','-','$cNDocumento'), '$cDocFiscal_id', '$cNSerie', '$cNDocumento', '$cFechaEmision',
                    '$cFechaEmision', CASE WHEN '$cMoneda' = '02' THEN '$cAcuenta' * '$cTipoCambio' ELSE '$cAcuenta' END, '$cCliente_Id', '$cNombre', '$cMoneda', '$cTipoCambio', '$idVenta', 'VTA', '$cObservacion', '1', '$cEmpresa_Id',
                    '$cSucursal_Id')";
    
                $resultadoCajaActa = mysqli_query($conn, $queryCajaActa);
                if (!$resultadoCajaActa) {
                    throw new Exception(mysqli_error($conn));
                }    
           };
        
           $queryCreditosxCob = "INSERT INTO creditos_cobrar(nserie, ndocumento, nro_letra, nro_unico, fecha, fecha_vencimiento, documento_identidad, 
                razon_social, direccion, deuda_soles, deuda_dolar, moneda, tipo_cambio, cliente_id, empleado_id, venta_id, sucursal_id, empresa_id)
                VALUES('$cNSerie', '$cNDocumento', '$cNSerie', '$cNDocumento', '$cFechaEmision', '$cFechaVencimiento', '$cDocIdentidad', '$cNombre', '$cDireccion',
                IF('$cMoneda'='01','$cTotal',0), IF('$cMoneda'='02','$cTotal',0), '$cMoneda', '$cTipoCambio', '$cCliente_Id', '$cEmpleado_id', '$idVenta', 
                '$cSucursal_Id','$cEmpresa_Id')"; 

            $resultadoCreditosxCob = mysqli_query($conn, $queryCreditosxCob);
            if (!$resultadoCreditosxCob) {
                throw new Exception(mysqli_error($conn));
            }    

        };

        // Ejemplo de inserción en la tabla detalle
        foreach ($data['detalle'] as $detalle_) {
            $cOperacion = 'VTA';
            $cAlmacen_Id = $detalle_['almacen_id'];
            $cProducto_Id = $detalle_['producto_id'];
            $cBonificdProd = $detalle_['bonificacion'];
            $cCodProd = $detalle_['codigo_producto'];
            $cCantidad = $detalle_['cantidad'];
            $cRecogido = $detalle_['recogido'];
            $cCapacidad_Precio = $detalle_['capacidad_precio'];
            $cDescrip_Precio = $detalle_['descrip_precio'];
            $cPrecio_Bruto = $detalle_['precio_bruto'];
            $cDescuento = $detalle_['descuento'];
            $cPrecio = $detalle_['precio'];
            $cPrecioigv = $detalle_['precioigv'];
            $cIgv = $detalle_['igv'];
            $cPercepcion = $detalle_['percepcion'];
            $cAfecto = $detalle_['afecto'];
            $cInafecto = $detalle_['inafecto'];
            $cExonerado = $detalle_['exonerado'];
            $cSubtotal = $detalle_['subtotal'];
            $cSubtotaligv = $detalle_['subtotaligv'];
            $cMargen = $detalle_['margen'];
            $cCosto = $detalle_['costo'];
            $cPeso = $detalle_['peso'];
            $cPorcentaje_Igv = $detalle_['porcentaje_igv'];
            $cIcbp = $detalle_['icbp'];
            $cDescripcion_Servicio = $detalle_['descripcion_servicio'];
            $cVencimiento = $detalle_['vencimiento'];
            $cLote = $detalle_['lote'];
            $cAbrev_Universal = $detalle_['abrev_universal'];
            $cRazon_Social = $cNombre;
            $cObservacion = $cObservacion;
            $cIdDocFis = $cDocFiscal_id;
            /*$cCategoria_Id = $detalle_['categoria_id'];
            $cMarca_Id = $detalle_['marca_id'];
            $cModelo_Id = $detalle_['modelo_id'];*/

            $queryDetalle = "INSERT INTO detventas (venta_id, almacen_id, producto_id, bonificacion, cantidad, recogido, 
             capacidad_precio, descrip_precio, precio_bruto, descuento, precio, precioigv, igv, percepcion, afecto, inafecto, 
             exonerado, subtotal, subtotaligv, margen, costo, peso, porcentaje_igv, icbp, descripcion_servicio, vencimiento, lote, abrev_universal) 
            VALUES ('$idVenta', '$cAlmacen_Id', '$cProducto_Id', '$cBonificdProd', '$cCantidad', '$cRecogido', '$cCapacidad_Precio', 
            '$cDescrip_Precio', '$cPrecio_Bruto', '$cDescuento', '$cPrecio', '$cPrecioigv', '$cIgv', '$cPercepcion', '$cAfecto', 
            '$cInafecto', '$cExonerado', '$cSubtotal', '$cSubtotaligv', '$cMargen', '$cCosto', '$cPeso', '$cPorcentaje_Igv', '$cIcbp', 
            '$cDescripcion_Servicio', '$cVencimiento', '$cLote', '$cAbrev_Universal')";
            
            $resultadoDetalle = mysqli_query($conn, $queryDetalle);
            if (!$resultadoDetalle) {
                throw new Exception(mysqli_error($conn));
            }

            //KARDEX
            if ($cAfectaKardex == 1) {
               $queryKardex = "INSERT INTO kardex(nserie, ndocumento, fecha_emision, fecha_traslado, operacion, producto_id, codigo_producto, entrada, costo, 
                salida, precio_venta, recogido, vencimiento, lote, transito, razon_social, observacion, unidad_medida, empresa_id, sucursal_id, 
                almacen_id, compra_id, venta_id, capacidad_Precio, docfiscal_id)
               VALUES('$cNSerie', '$cNDocumento', '$cFechaEmision', '$cFechaTraslado', '$cOperacion', '$cProducto_Id', '$cCodProd', 0, '$cCosto',
                ('$cCantidad'*'$cCapacidad_Precio'), '$cPrecioigv', ('$cRecogido'*'$cCapacidad_Precio') * -1, '$cVencimiento', '$cLote', 0, '$cNombre', '$cObservacion', 
                '$cDescrip_Precio', '$cEmpresa_Id', '$cSucursal_Id', '$cAlmacen_Id', 0, '$idVenta', '$cCapacidad_Precio', '$cIdDocFis')";

                $resultadoKardex = mysqli_query($conn, $queryKardex);
                if (!$resultadoKardex) {
                    throw new Exception(mysqli_error($conn));
                }
	         
	        }; 
        }

        // Ejemplo de inserción en la tabla cuotas
        foreach ($data['cuotas'] as $cuota) {
            $cVenta_Id = $idVenta; // Usar el mismo Id_Venta generado
            $cNroCuota = $cuota['numero_cuota'];
            $cImporte = $cuota['importe']; //
            $cFechaPago = $cuota['fecha_pago'];
            $cCliente_Id = $cuota['cliente_id'];
            //$cEmpresa_Id = $cuota['Empresa_id'];
            //$cSucursal_Id = $cuota['Sucursal_id'];

            $queryCuotas = "INSERT INTO cuotasclientes(venta_id, numero_cuota, importe, fecha_pago, cliente_id, empresa_id, sucursal_id)
            VALUES('$cVenta_Id', '$cNroCuota', '$cImporte', '$cFechaPago', '$cCliente_Id', '$cEmpresa_Id', '$cSucursal_Id')"; 
            
            $resultadoCuotas = mysqli_query($conn, $queryCuotas);   
            if (!$resultadoCuotas) {
                throw new Exception(mysqli_error($conn));
            }
        }
        
        if ($cAfectaKardex == 1) {
            // Ejemplo de inserción en la tabla series
            foreach ($data['series'] as $serie) {
                $cSerie = $serie['serie'];
                $cPlanVta = $serie['plan_venta'];
                $cModalidadVta = $serie['modalidad_venta'];
                $cNumCelular = $serie['numero_celular'];
                $cCantidad = $serie['salida'];
                $cIdProducto = $serie['producto_id'];
                $cAlmacenId = $serie['almacen_id'];
                $cCuotaInicial = $serie['cuota_inicial'];
                $cCuotaEquipo = $serie['cuota_equipo'];
            
                if (isset($cSerie) || !empty($cSerie)) {
                    $querySerieProducto = "INSERT INTO kardex_serieprod (producto_id, serie, plan_venta, modalidad_venta, numero_celular, cantidad, movimiento_id, operacion, nserie, ndocumento, cuota_inicial, cuota_equipo,
                               fecha, empresa_id, sucursal_id, almacen_id)
                        VALUES('$cIdProducto', '$cSerie', '$cPlanVta', '$cModalidadVta', '$cNumCelular', '$cCantidad'*-1, '$idVenta', 'VTA', '$cNSerie', '$cNDocumento', '$cCuotaInicial', '$cCuotaEquipo',
                               '$cFechaEmision', '$cEmpresa_Id', '$cSucursal_Id', '$cAlmacenId')";
                    $resultadoSerieProducto = mysqli_query($conn, $querySerieProducto);        
                
                    if (!$resultadoSerieProducto) {
                        throw new Exception(mysqli_error($conn));
                    }
                }
            }
        }

        // Ejemplo de inserción en la tabla canje de documentos
        foreach ($data['canje'] as $canje) {
            $nDetalle_Id = $canje['detalle_id'];
            $nVenta_Id = $canje['venta_id']; 
            $nProducto_Id = $canje['producto_id'];
            $nAlmacen_Id = $canje['almacen_id'];
            $nCantidad = $canje['cantidad'];
        
            // Modificar la consulta con la condición deseada
            $queryCanje_Det = "UPDATE detventas 
                               SET canjeado = IF(cantidad = $nCantidad, 1, 0), venta_relacionada = $nVenta_Id
                               WHERE id = $nDetalle_Id AND Producto_Id = $nProducto_Id AND Almacen_id = $nAlmacen_Id";
            $resultadoCanje_Det = mysqli_query($conn, $queryCanje_Det);   
            if (!$resultadoCanje_Det) {
                throw new Exception(mysqli_error($conn));
            }
        
            $queryCount_Det = "SELECT COUNT(id) FROM detventas WHERE venta_id = $nVenta_Id AND canjeado = 0";
            $result_Det = mysqli_query($conn, $queryCount_Det); 
            if (!$result_Det) {
                die("Error al ejecutar la consulta: " . mysqli_error($conn));
            }
             
            $row = mysqli_fetch_array($result_Det);
            $count_Det = $row[0];
            if ($count_Det == 0) {
                $queryCanje = "UPDATE ventas SET canjeado = 1 WHERE id = $nVenta_Id"; 
                $resultadoCanje = mysqli_query($conn, $queryCanje);   
                if (!$resultadoCanje) {
                    throw new Exception(mysqli_error($conn));
                }
            } 
        }


    } elseif ($cEstado == 'MODIFICAR') { 
        $queryUpd_DetVtas = "UPDATE detventas SET IUD = 'D' WHERE venta_id = $iIdVta";
        $resultadoUpd_DetVtas = mysqli_query($conn, $queryUpd_DetVtas);        
        if (!$resultadoUpd_DetVtas) {
            throw new Exception(mysqli_error($conn));
        }
        
        $queryDel_DetCaja = "DELETE FROM detcaja WHERE movimiento_id = $iIdVta AND operacion = 'VTA'";
        $resultadoDel_DetCaja = mysqli_query($conn, $queryDel_DetCaja);        
        if (!$resultadoDel_DetCaja) {
           throw new Exception(mysqli_error($conn));
        }
        
        $queryUpd_Kardex = "UPDATE kardex SET IUD = 'D' WHERE venta_id = $iIdVta";
        $resultadoUpd_Kardex = mysqli_query($conn, $queryUpd_Kardex);        
        if (!$resultadoUpd_Kardex) {
            throw new Exception(mysqli_error($conn));
        }

        $queryUpd_Cuotas = "UPDATE cuotasclientes SET IUD = 'D' WHERE venta_id = $iIdVta";
        $resultadoUpd_Cuotas = mysqli_query($conn, $queryUpd_Cuotas);        
        if (!$resultadoUpd_Cuotas) {
            throw new Exception(mysqli_error($conn));
        }

        $queryUpd_Kardex_Serie = "UPDATE kardex_serieprod SET IUD = 'D' WHERE movimiento_id = $iIdVta AND operacion = 'VTA'";
        $resultadoUpd_Kardex_Serie = mysqli_query($conn, $queryUpd_Kardex_Serie);        
        if (!$resultadoUpd_Kardex_Serie) {
            throw new Exception(mysqli_error($conn));
        }

        $queryUpd_Ventas = "UPDATE ventas SET empresa_id = '$cEmpresa_Id', docfiscal_id = '$cDocFiscal_id', nserie = '$cNSerie', ndocumento = '$cNDocumento', 
             fecha_emision = '$cFechaEmision', fecha_traslado = '$cFechaTraslado', fecha_vencimiento = '$cFechaVencimiento', razon_social = '$cNombre',
             direccion = '$cDireccion', tipo_docidentidad = '$cTipDocIdent', documento_identidad = '$cDocIdentidad', nro_dias = '$cNDias', 
             moneda = '$cMoneda', tipo_cambio = '$cTipoCambio', afecto_igv = '$cAfectoIgv', porcentaje_igv = '$cP_Igv', igv = '$cIgv', 
             afecto_dscto = '$cAfectDscto', porcentaje_dscto = '$cP_Dscto', descuento = '$cDescuento', afecto_percepcion = '$cAfectoPercepcion', 
             porcentaje_percepcion = '$cP_Percepcion', percepcion = $cPercepcion, afecto = '$cAfecto', inafecto = '$cInafecto', exonerado = '$cExonerado',
             total = '$cTotal', guia_remision = '$cGuiaRemision', cancelado = '$cCancelado', icbp = '$cIcbp', gratuitas = '$cGratuitas', 
             afecta_kardex = '$cAfectaKardex', afecta_caja = $cAfectaCaja, servicio = '$cServicio', periodo = '$cPeriodo', mes = '$cMes', formapago_id = '$cFormaPago_Id',
             caja_id = '$cCaja_Id', cliente_id = '$cCliente_Id', empleado_id = '$cEmpleado_id', sucursal_id = '$cSucursal_Id', observacion = '$cObservacion', acuenta = '$cAcuenta',
             zona_id = '$cZona_Id', placa_id = '$cPlaca', valor_referencial = '$cValorRef'
           WHERE id = $iIdVta";
        
        $resultadoUpd_Ventas = mysqli_query($conn, $queryUpd_Ventas);        
        if (!$resultadoUpd_Ventas) {
            throw new Exception(mysqli_error($conn));
        }
           
        // REGISTRO DE VENTAS
        if ($cDocFiscal_id == 2 || $cDocFiscal_id == 4) {
           $queryUpd_RegVtas = "UPDATE registro_ventas SET nserie = '$cNSerie', ndocumento = '$cNDocumento', fecha_emision = '$cFechaEmision', 
               fecha_vencimiento = '$cFechaVencimiento', tipo_docidentidad = '$cTipDocIdent', documento_identidad = '$cDocIdentidad',
               razon_social = '$cNombre', afecto = CASE WHEN '$cMoneda' = '02' THEN '$cAfecto' * '$cTipoCambio' ELSE '$cAfecto' END,
               exonerado = CASE WHEN '$cMoneda' = '02' THEN '$cExonerado' * '$cTipoCambio' ELSE '$cExonerado' END,
               inafecto = CASE WHEN '$cMoneda' = '02' THEN '$cInafecto' * '$cTipoCambio' ELSE '$cInafecto' END,
               igv = CASE WHEN '$cMoneda' = '02' THEN '$cIgv' * '$cTipoCambio' ELSE '$cIgv' END,
               total = CASE WHEN '$cMoneda' = '02' THEN '$cTotal' * '$cTipoCambio' ELSE '$cTotal' END,
               periodo = '$cPeriodo', mes = '$cMes', moneda = '$cMoneda', tipo_cambio = '$cTipoCambio', docfiscal_id = '$cDocFiscal_id'
               WHERE venta_id = $iIdVta";
                
            $resultadoUpd_RegVtas = mysqli_query($conn, $queryUpd_RegVtas);        
            if (!$resultadoUpd_RegVtas) {
               throw new Exception(mysqli_error($conn));
            }
        } else {
            $queryDel_RegVtas = "DELETE FROM registro_ventas WHERE venta_id = $iIdVta";
             
            $resultadoDel_RegVtas = mysqli_query($conn, $queryDel_RegVtas);        
            if (!$resultadoDel_RegVtas) {
               throw new Exception(mysqli_error($conn));
            }
        };
           
        // CAJA
        /*$queryDel_DetCaja = "DELETE FROM detcaja WHERE movimiento_id = $iIdVta AND operacion = 'VTA'";
             
        $resultadoDel_DetCaja = mysqli_query($conn, $queryDel_DetCaja);        
        if (!$resultadoDel_DetCaja) {
           throw new Exception(mysqli_error($conn));
        }*/
        
        if ($cAfectaCaja == 1 && $cFormaPago_Id == 1) {
           /* if ($cFormaPago_Id == 2) {
             $queryDel_DetCaja = "DELETE FROM detcaja WHERE movimiento_id = $iIdVta AND operacion = 'VTA'";
             
             $resultadoDel_DetCaja = mysqli_query($conn, $queryDel_DetCaja);        
             if (!$resultadoDel_DetCaja) {
                throw new Exception(mysqli_error($conn));
             }
            }; */ 
             
           $queryCount = "SELECT COUNT(id) FROM detcaja WHERE movimiento_id = $iIdVta AND operacion = 'VTA'";
           $result = mysqli_query($conn, $queryCount); // Suponiendo que has establecido una conexión a la base de datos ($conexion)
           if (!$result) {
              // Manejo de error si la consulta falla
              die("Error al ejecutar la consulta: " . mysqli_error($conn));
           }
             
           $row = mysqli_fetch_array($result);
           $count = $row[0];
           if ($count == 0) {
               $queryUpd_DetCaja = "INSERT INTO detcaja(cuenta_id, tipo_movcaja, nrecibo, docfiscal_id, nserie, ndocumento, fecha_operacion,
                 fecha_emision, ingreso, partida_id, nombre_partida, moneda, tipo_cambio, movimiento_id, operacion, 
                 observacion, offsystem, empresa_id, sucursal_id)
               VALUES('$cCaja_Id', 'I', CONCAT('$cNSerie','-','$cNDocumento'), '$cDocFiscal_id', '$cNSerie', '$cNDocumento', '$cFechaEmision',
                 '$cFechaEmision', CASE WHEN '$cMoneda' = '02' THEN '$cTotal' * '$cTipoCambio' ELSE '$cTotal' END, '$cCliente_Id', '$cNombre', '$cMoneda', '$cTipoCambio', '$iIdVta', 'VTA', '$cObservacion', 1, '$cEmpresa_Id',
                 '$cSucursal_Id')";
           } else {
               $queryUpd_DetCaja = "UPDATE detcaja SET cuenta_id = '$cCaja_Id', tipo_movcaja = 'I', nrecibo = CONCAT('$cNSerie','-','$cNDocumento'),
                 fecha_operacion = '$cFechaEmision', docfiscal_id = '$cDocFiscal_id', nserie = '$cNSerie', ndocumento = '$cNDocumento', 
                 fecha_emision = '$cFechaEmision', ingreso = CASE WHEN '$cMoneda' = '02' THEN '$cTotal' * '$cTipoCambio' ELSE '$cTotal' END, partida_id = '$cCliente_Id', nombre_partida = '$cNombre', 
                 moneda = '$cMoneda', tipo_cambio = '$cTipoCambio', observacion = '$cObservacion' WHERE movimiento_id = $iIdVta AND operacion = 'VTA'";
           }
           $resultUpdate = mysqli_query($conn, $queryUpd_DetCaja);
           if (!$resultUpdate) {
               // Manejo de error si la actualización falla
               die("Error al ejecutar la actualización: " . mysqli_error($conn));
           }
             
        }; 
           
        // CREDITOS POR COBRAR
        if ($cFormaPago_Id == 2) {
            if ($cAcuenta > 0) {
                $queryCount = "SELECT COUNT(id) FROM detcaja WHERE movimiento_id = $iIdVta AND operacion = 'VTA'";
                $result = mysqli_query($conn, $queryCount); // Suponiendo que has establecido una conexión a la base de datos ($conexion)
                if (!$result) {
                          // Manejo de error si la consulta falla
                    die("Error al ejecutar la consulta: " . mysqli_error($conn));
                }
                     
                $row = mysqli_fetch_array($result);
                $count = $row[0];
                if ($count == 0) {
                        $queryUpd_CajaActa = "INSERT INTO detcaja(cuenta_id, nombre, tipo_movcaja, nrecibo, docfiscal_id, nserie, ndocumento, fecha_operacion,
                            fecha_emision, ingreso, partida_id, nombre_partida, moneda, tipo_cambio, movimiento_id, operacion, 
                            observacion, offsystem, empresa_id, sucursal_id)
                        VALUES('$cCaja_Id', '$cCaja_Nombre', 'I', CONCAT('$cNSerie','-','$cNDocumento'), '$cDocFiscal_id', '$cNSerie', '$cNDocumento', '$cFechaEmision',
                            '$cFechaEmision', CASE WHEN '$cMoneda' = '02' THEN '$cAcuenta' * '$cTipoCambio' ELSE '$cAcuenta' END, '$cCliente_Id', '$cNombre', '$cMoneda', '$cTipoCambio', '$iIdVta', 'VTA', '$cObservacion', '1', '$cEmpresa_Id',
                            $cSucursal_Id')";
                } else {
                       $queryUpd_CajaActa = "UPDATE detcaja SET cuenta_id = '$cCaja_Id', tipo_movcaja = 'I', nrecibo = CONCAT('$cNSerie','-','$cNDocumento'),
                         fecha_operacion = '$cFechaEmision', docfiscal_id = '$cDocFiscal_id', nserie = '$cNSerie', ndocumento = '$cNDocumento', 
                         fecha_emision = '$cFechaEmision', ingreso = CASE WHEN '$cMoneda' = '02' THEN '$cAcuenta' * '$cTipoCambio' ELSE '$cAcuenta' END, partida_id = '$cCliente_Id', nombre_partida = '$cNombre', 
                         moneda = '$cMoneda', tipo_cambio = '$cTipoCambio', observacion = '$cObservacion' WHERE movimiento_id = $iIdVta AND operacion = 'VTA'";
                }
                $resultadoCajaActa = mysqli_query($conn, $queryUpd_CajaActa);
                if (!$resultadoCajaActa) {
                    throw new Exception(mysqli_error($conn));
                }  
            }; 
            
            $queryCountCxC = "SELECT COUNT(id) FROM creditos_cobrar WHERE venta_id = $iIdVta";
            $result_CxC = mysqli_query($conn, $queryCountCxC); // Suponiendo que has establecido una conexión a la base de datos ($conexion)
            if (!$result_CxC) {
               // Manejo de error si la consulta falla
               die("Error al ejecutar la consulta: " . mysqli_error($conn));
            }
              
            $row_ = mysqli_fetch_array($result_CxC);
            $count_ = $row_[0];
            if ($count_ == 0) {
                $queryCreditosxCob = "INSERT INTO creditos_cobrar(nserie, ndocumento, nro_letra, nro_unico, fecha, fecha_vencimiento, documento_identidad, 
                        razon_social, direccion, deuda_soles, deuda_dolar, moneda, tipo_cambio, cliente_id, empleado_id, venta_id, sucursal_id, empresa_id)
                    VALUES('$cNSerie', '$cNDocumento', '$cNSerie', '$cNDocumento', '$cFechaEmision', '$cFechaVencimiento', '$cDocIdentidad', '$cNombre', '$cDireccion',
                        IF('$cMoneda'='01','$cTotal',0), IF('$cMoneda'='02','$cTotal',0), '$cMoneda', '$cTipoCambio', '$cCliente_Id', '$cEmpleado_id', '$iIdVta', 
                        '$cSucursal_Id','$cEmpresa_Id')"; 
            } else {
                $queryCreditosxCob = "UPDATE creditos_cobrar SET nserie = '$cNSerie', ndocumento = '$cNDocumento', nro_letra = '$cNSerie', nro_unico = '$cNDocumento', 
                    fecha = '$cFechaEmision', fecha_vencimiento = '$cFechaVencimiento', razon_social = '$cNombre', 
                    deuda_soles = IF('$cMoneda'='01','$cTotal',0), deuda_dolar = IF('$cMoneda'='02','$cTotal',0), moneda = '$cMoneda', 
                    tipo_cambio = '$cTipoCambio', cliente_id = '$cCliente_Id', empleado_id = '$cEmpleado_id' WHERE venta_id = $iIdVta";
            }

            $resultadoCreditosxCob = mysqli_query($conn, $queryCreditosxCob);
            if (!$resultadoCreditosxCob) {
                throw new Exception(mysqli_error($conn));
            } 
         } else {
            $queryDelCxC = "DELETE FROM creditos_cobrar WHERE venta_id = $iIdVta";
            $resultadoDelCxC = mysqli_query($conn, $queryDelCxC);        
            if (!$resultadoDelCxC) {
                throw new Exception(mysqli_error($conn));
            }
        }

         // Ejemplo de inserción en la tabla detalle  foreach ($data['ventas'] as $detalle_) {
        foreach ($data['detalle'] as $detalle_) {
            $cOperacion = 'VTA';
            $cAlmacen_Id = $detalle_['almacen_id'];
            $cProducto_Id = $detalle_['producto_id'];
            $cBonificdProd = $detalle_['bonificacion'];
            $cCodProd = $detalle_['codigo_producto'];
            $cCantidad = $detalle_['cantidad'];
            $cRecogido = $detalle_['recogido'];
            $cCapacidad_Precio = $detalle_['capacidad_precio'];
            $cDescrip_Precio = $detalle_['descrip_precio'];
            $cPrecio_Bruto = $detalle_['precio_bruto'];
            $cDescuento = $detalle_['descuento'];
            $cPrecio = $detalle_['precio'];
            $cPrecioigv = $detalle_['precioigv'];
            $cIgv = $detalle_['igv'];
            $cPercepcion = $detalle_['percepcion'];
            $cAfecto = $detalle_['afecto'];
            $cInafecto = $detalle_['inafecto'];
            $cExonerado = $detalle_['exonerado'];
            $cSubtotal = $detalle_['subtotal'];
            $cSubtotaligv = $detalle_['subtotaligv'];
            $cMargen = $detalle_['margen'];
            $cCosto = $detalle_['costo'];
            $cPeso = $detalle_['peso'];
            $cPorcentaje_Igv = $detalle_['porcentaje_igv'];
            $cIcbp = $detalle_['icbp'];
            $cDescripcion_Servicio = $detalle_['descripcion_servicio'];
            $cVencimiento = $detalle_['vencimiento'];
            $cLote = $detalle_['lote'];
            $cAbrev_Universal = $detalle_['abrev_universal'];
            $cRazon_Social = $cNombre;
            $cObservacion = $cObservacion;
            $cIdDocFis = $cDocFiscal_id;
            /*$cCategoria_Id = $detalle_['categoria_id'];
            $cMarca_Id = $detalle_['marca_id'];
            $cModelo_Id = $detalle_['modelo_id'];*/

            $queryDetalle = "INSERT INTO detventas (venta_id, almacen_id, producto_id, bonificacion, cantidad, recogido, 
             capacidad_precio, descrip_precio, precio_bruto, descuento, precio, precioigv, igv, percepcion, afecto, inafecto, exonerado, 
             subtotal, subtotaligv, margen, costo, peso, porcentaje_igv, icbp, descripcion_servicio, vencimiento, lote, abrev_universal) 
            VALUES ('$iIdVta', '$cAlmacen_Id', '$cProducto_Id', '$cBonificdProd', '$cCantidad', '$cRecogido', '$cCapacidad_Precio', 
            '$cDescrip_Precio', '$cPrecio_Bruto', '$cDescuento', '$cPrecio', '$cPrecioigv', '$cIgv', '$cPercepcion', '$cAfecto', '$cInafecto', 
            '$cExonerado', '$cSubtotal', '$cSubtotaligv', '$cMargen', '$cCosto', '$cPeso', '$cPorcentaje_Igv', '$cIcbp', '$cDescripcion_Servicio', 
            '$cVencimiento', '$cLote', '$cAbrev_Universal')";
            $resultadoDetalle = mysqli_query($conn, $queryDetalle);

            if (!$resultadoDetalle) {
                throw new Exception(mysqli_error($conn));
            }

            //KARDEX
            if ($cAfectaKardex == 1) {
                $queryKardex = "INSERT INTO kardex(nserie, ndocumento, fecha_emision, fecha_traslado, operacion, producto_id, codigo_producto, entrada, costo, 
                 salida, precio_venta, recogido, vencimiento, lote, transito, razon_social, observacion, unidad_medida, empresa_id, sucursal_id, 
                 almacen_id, compra_id, venta_id, capacidad_Precio, docfiscal_id)
                VALUES('$cNSerie', '$cNDocumento', '$cFechaEmision', '$cFechaTraslado', '$cOperacion', '$cProducto_Id', '$cCodProd', 0, '$cCosto',
                 ('$cCantidad'*'$cCapacidad_Precio'), '$cPrecioigv', ('$cRecogido'*'$cCapacidad_Precio') * -1, '$cVencimiento', '$cLote', 0, '$cNombre', '$cObservacion', 
                 '$cDescrip_Precio', '$cEmpresa_Id', '$cSucursal_Id', '$cAlmacen_Id', 0, '$iIdVta', '$cCapacidad_Precio', '$cIdDocFis')";
 
                 $resultadoKardex = mysqli_query($conn, $queryKardex);
                 if (!$resultadoKardex) {
                     throw new Exception(mysqli_error($conn));
                 }

             }; 
        }

        // Ejemplo de inserción en la tabla cuotas
        foreach ($data['cuotas'] as $cuota) {
            $cVenta_Id = $iIdVta; // Usar el mismo Id_Venta generado
            $cNroCuota = $cuota['numero_cuota'];
            $cImporte = $cuota['importe']; //
            $cFechaPago = $cuota['fecha_pago'];
            $cCliente_Id = $cuota['cliente_id'];
            //$cEmpresa_Id = $cuota['Empresa_id'];
            //$cSucursal_Id = $cuota['Sucursal_id'];

            $queryCuotas = "INSERT INTO cuotasclientes(venta_id, numero_cuota, importe, fecha_pago, cliente_id, empresa_id, sucursal_id)
            VALUES('$cVenta_Id', '$cNroCuota', '$cImporte', '$cFechaPago', '$cCliente_Id', '$cEmpresa_Id', '$cSucursal_Id')"; 
            
            $resultadoCuotas = mysqli_query($conn, $queryCuotas);   
            if (!$resultadoCuotas) {
                throw new Exception(mysqli_error($conn));
            }
        }
        
        if ($cAfectaKardex == 1) {
            // Ejemplo de inserción en la tabla series
            foreach ($data['series'] as $serie) {
                $cSerie = $serie['serie'];
                $cPlanVta = $serie['plan_venta'];
                $cModalidadVta = $serie['modalidad_venta'];
                $cNumCelular = $serie['numero_celular'];
                $cCantidad = $serie['salida'];
                $cIdProducto = $serie['producto_id'];
                $cAlmacenId = $serie['almacen_id'];
                $cCuotaInicial = $serie['cuota_inicial'];
                $cCuotaEquipo = $serie['cuota_equipo'];
            
                if (isset($cSerie) || !empty($cSerie)) {
                    $querySerieProducto = "INSERT INTO kardex_serieprod (producto_id, serie, plan_venta, modalidad_venta, numero_celular, cantidad, movimiento_id, operacion, nserie, ndocumento, cuota_inicial, cuota_equipo,
                               fecha, empresa_id, sucursal_id, almacen_id)
                        VALUES('$cIdProducto', '$cSerie', '$cPlanVta', '$cModalidadVta', '$cNumCelular', '$cCantidad'*-1, '$iIdVta', 'VTA', '$cNSerie', '$cNDocumento', '$cCuotaInicial', '$cCuotaEquipo',
                               '$cFechaEmision', '$cEmpresa_Id', '$cSucursal_Id', '$cAlmacenId')";
                    $resultadoSerieProducto = mysqli_query($conn, $querySerieProducto);
                
                    if (!$resultadoSerieProducto) {
                        throw new Exception(mysqli_error($conn));
                    }
                }
            }
        }

        // INSERT kardex_serieprod desde del tempkardex_serieprod
        /*if ($cAfectaKardex == 1) {
            $querySerieProducto = "INSERT INTO kardex_serieprod (producto_id, serie, cantidad, movimiento_id, operacion, nserie, ndocumento, empresa_id, sucursal_id, almacen_id, plan_venta, modalidad_venta, numero_celular) 
                SELECT producto_id, serie, cantidad, '$iIdVta', operacion, nserie, ndocumento, empresa_id, sucursal_id, almacen_id, plan_venta, modalidad_venta, numero_celular FROM tempkardex_serieprod 
                WHERE movimiento_id = $iIdVta AND operacion = 'VTA'";
            
            $resultadoSerieProducto = mysqli_query($conn, $querySerieProducto);        
            if (!$resultadoSerieProducto) {
               throw new Exception(mysqli_error($conn));
            }
        }*/

        //Elimina Detalle de Venta para Evitar la Duplicidad
        $queryDelVtas = "DELETE FROM detventas WHERE venta_id = $iIdVta AND IUD = 'D'";
        $resultadoDelVtas = mysqli_query($conn, $queryDelVtas);        
        if (!$resultadoDelVtas) {
           throw new Exception(mysqli_error($conn));
        }

        //Elimina Kardex para Evitar la Duplicidad
	    $queryDelKardex = "DELETE FROM kardex WHERE venta_id = $iIdVta AND IUD = 'D'";
        $resultadoDelKardex = mysqli_query($conn, $queryDelKardex);        
        if (!$resultadoDelKardex) {
           throw new Exception(mysqli_error($conn));
        }

        //Elimina Cuotas del Cliente para Evitar la Duplicidad
	    $queryDelCuotas = "DELETE FROM cuotasclientes WHERE venta_id = $iIdVta AND IUD = 'D'";
        $resultadoDelCuotas = mysqli_query($conn, $queryDelCuotas);        
        if (!$resultadoDelCuotas) {
           throw new Exception(mysqli_error($conn));
        }

        //Elimina Kardex Serie para Evitar la Duplicidad
	    $queryDelKardexSerie = "DELETE FROM kardex_serieprod WHERE movimiento_id = $iIdVta AND operacion = 'VTA' AND IUD = 'D'";
        $resultadoDelKardexSerie = mysqli_query($conn, $queryDelKardexSerie);        
        if (!$resultadoDelKardexSerie) {
           throw new Exception(mysqli_error($conn));
        }
    }

    // Confirmar la transacción
    mysqli_commit($conn);
    
} catch (Exception $e) {
    // Revertir la transacción en caso de error
    mysqli_rollback($conn);
    $transaccionExitosa = false;
    $errorMensaje = $e->getMessage();
}

// Cerrar la conexión a la base de datos
mysqli_close($conn);

// Enviar una respuesta al cliente
if ($transaccionExitosa) {
    $response = array();
    //$response = array("ESTADO" => "00", "MENSAJE" => "Los datos se han guardado correctamente");
    if ($cEstado == 'NUEVO') {
        if ($idVenta > 0) {
            //$response = array();
            $response['ESTADO'] = "00";
            $response['ID'] = $idVenta;
            $response['MENSAJE'] = "Los datos se han guardado correctamente";
        } else {
            //$response = array();
            $response['ESTADO'] = "11";
            $response['ID'] = 0;
            $response['MENSAJE'] = "Error al guardar la información: " . $errorMensaje;
        }
    } else {
        //$response = array();
        $response['ESTADO'] = "00";
        $response['ID'] = $iIdVta;
        $response['MENSAJE'] = "Los datos se actualizaron correctamente";
    }
} else {
    //$response = array("ESTADO" => "11", "MENSAJE" => "Error al guardar la información: " . $errorMensaje);
    $response = array();
    $response['ESTADO'] = "111";
    $response['ID'] = 0;
    $response['MENSAJE'] = "Error al guardar la información: " . $errorMensaje;
}
echo json_encode($response);

?>
